#include "data.h"

extern __inline__ __attribute__((always_inline))
long long
rmpaw (long long init, unsigned long count, short *a, short *b)
{
  register long long rv __asm__("r4") = init;
  register unsigned long count_out __asm__("r3") = count;
  register short *a_out __asm__("r1") = a;
  register short *b_out __asm__("r2") = b;

  __asm__ volatile ("rmpa.w"
		: "=r" (rv), "=r" (count_out) , "=r" (a_out), "=r" (b_out)
		: "0" (rv), "1" (count_out), "2" (a_out), "3" (b_out)
		: "r6");
  return rv;
}

long long mac (short *a, short *b, int len)
{
  return rmpaw (0, len, a, b);
}
